<template>
    <div class="gdpr-bar" v-if="isVisible">
        <div class="gdpr-bar__wrapper">
            <div class="gdpr-bar__content" v-html="computedContent"></div>
            <div class="gdpr-bar__buttons">
                <button class="gdpr-btn gdpr-bar__preferences" type="button" @click="onClickPreferences" v-if="buttonPreferences">
                    {{ buttonPreferences }}
                </button>
                <button class="gdpr-btn gdpr-bar__agreement" type="button" @click="onClickAgreement">
                    {{ buttonAgreement }}
                </button>
                <button class="gdpr-btn gdpr-bar__close" type="button" @click="onCloseBar" v-if="buttonClose">
                    {{ buttonClose }}
                </button>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'gdpr-bar',
    props: {
        buttonAgreement: {
            default: 'Agreement',
            type: String,
        },
        buttonPreferences: {
            default: null,
            type: String,
        },
        buttonClose: {
            default: null,
            type: String,
        },
        content: {
            required: true,
            type: String,
        },
        levels: {
            default() {
                return {
                    required: null,
                    third_party: null,
                };
            },
            type: Object,
        },
        shortcodes: {
            default() {
                return {
                    settings: 'gdpr_settings',
                };
            },
            type: Object,
        },
    },
    data() {
        return {
            isVisible: false,
        };
    },
    computed: {
        /**
         * Return content with replaced shortcode.
         */
        computedContent() {
            const regex = new RegExp(`\\[${this.shortcodes.settings}\\](.*)\\[\/${this.shortcodes.settings}\\]`, 'g');
            return this.content.replace(regex, '<button type="button" data-gdpr-preferences>$1</button>');
        },
    },
    watch: {
        isVisible(value) {
            const body = document.body;

            this.removeEventListener();

            if (value) {
                body.classList.add('gdpr_bar-opened');
            } else {
                body.classList.remove('gdpr_bar-opened');
            }

            setTimeout(() => this.addEventListener());
        },
    },
    methods: {
        /**
         * Click on elements with [data-gdpr-preferences] to open Modal Preferences.
         */
        addEventListener() {
            const buttons = document.querySelectorAll('[data-gdpr-preferences]');
            buttons.forEach((button) => {
                button.addEventListener('click', (e) => {
                    e.preventDefault();
                    this.onClickPreferences();
                });
            });
        },

        /**
         * Close bar.
         */
        close() {
            this.isVisible = false;
        },

        /**
         * Open Modal Preferences.
         */
        onClickPreferences() {
            this.$root.$emit('gdpr_modal:open');
        },

        /**
         * When clicking on "agree", set the higher level available.
         */
        onClickAgreement() {
            const levels = Object.keys(this.levels);
            this.$gdpr.setLevel(levels[levels.length - 1], this.levels);
            this.close();
        },

        /**
         * When closing, set the lower level available (= required).
         */
        onCloseBar() {
            const levels = Object.keys(this.levels);
            this.$gdpr.setLevel(levels[0], this.levels);
            this.close();
        },

        /**
         * Open bar.
         */
        open() {
            this.isVisible = true;
        },

        /**
         * Remove all listeners on [data-gdpr-preferences] elements.
         */
        removeEventListener() {
            const buttons = document.querySelectorAll('[data-gdpr-preferences]');
            buttons.forEach((button) => {
                button.removeEventListener('click', (e) => {
                    e.preventDefault();
                    this.onClickPreferences();
                });
            });
        },
    },
    mounted() {
        // allow to open the bar from every where
        this.$root.$on('gdpr_bar:open', () => {
            this.open();
        });

        // allow to close the bar from every where
        this.$root.$on('gdpr_bar:close', () => {
            this.close();
        });

        this.addEventListener();

        // determine if we have to show the bar
        if (!this.$gdpr.getLevel() && this.$gdpr.isBarVisible) {
            this.open();
        }
    },
};
</script>

<style lang="scss">
:root {
    --gdpr-background: black;
    --gdpr-color: white;
    --gdpr-zindex: 1100;
    --gdpr-active: #a9cc8d;
    --gdpr-active-color: #fff;
    --gdpr-inactive: #e88388;
    --gdpr-inactive-color: #fff;
}

body.gdpr_bar-opened {}

.gdpr-btn {
    background-color: white;
    background-color: var(--gdpr-color);
    border-color: white;
    border: 1px solid var(--gdpr-color);
    color: black;
    color: var(--gdpr-background);
    display: inline-block;
    font-weight: bold;
    line-height: 1.4;
    margin: 0 5px;
    padding: .275rem .75rem;
    text-align: center;
    transition: background-color .15s ease-in-out, border-color .15s ease-in-out, color .15s ease-in-out;
    user-select: none;
    vertical-align: middle;

    &:focus, &:hover {
        background-color: black;
        background-color: var(--gdpr-background);
        color: white;
        color: var(--gdpr-color);
    }

    &:active, &:focus {
        outline: 3px solid rgba(255, 255, 255, .4);
    }
}

.gdpr-bar__agreement {
    background-color: #a9cc8d;
    background-color: var(--gdpr-active);
    border-color: #a9cc8d;
    border-color: var(--gdpr-active);
    color: #fff;
    color: var(--gdpr-active-color);

    &:focus, &:hover {
        background-color: #fff;
        background-color: var(--gdpr-active-color);
        color: #a9cc8d;
        color: var(--gdpr-active);
    }
}
.gdpr-bar__close {
    background-color: #e88388;
    background-color: var(--gdpr-inactive);
    border-color: #e88388;
    border-color: var(--gdpr-inactive);
    color: #fff;
    color: var(--gdpr-inactive-color);

    &:focus, &:hover {
        background-color: #fff;
        background-color: var(--gdpr-inactive-color);
        color: #e88388;
        color: var(--gdpr-inactive);
    }
}
.gdpr-bar__preferences {}

.gdpr-bar {
    background-color: black;
    background-color: var(--gdpr-background);
    border-color: white;
    border-top: 1px solid var(--gdpr-color);
    bottom: 0;
    color: white;
    color: var(--gdpr-color);
    font-size: .8em;
    left: 0;
    line-height: 1.1em;
    position: fixed;
    right: 0;
    z-index: 1100;
    z-index: var(--gdpr-zindex);

    @media (max-width: 575.98px) {}
    @media (min-width: 576px) {}
    @media (min-width: 768px) {
        .gdpr-bar__wrapper {
            align-items: center;
            display: flex;
            flex-direction: row;
            justify-content: space-between;
            padding: 20px 60px;

            .gdpr-bar__content {
                flex: 1;
                margin-bottom: 0;
                padding: 0 100px 0 0;

                p:last-child {
                    margin-bottom: 0;
                }
            }

            .gdpr-bar__buttons {
                align-items: center;
                display: flex;
            }
        }
    }
    @media (min-width: 992px) {}
    @media (min-width: 1200px) {}

    &__wrapper {
        padding: 20px;

        .gdpr-bar__content {
            margin-bottom: 1em;
            text-align: left;

            button,
            a {
                color: white;
                color: var(--gdpr-color);
                font-weight: bold;
                text-decoration: underline;

                &:hover, &:focus {
                    text-decoration: none;
                }
            }

            button {
                background: none;
                border: none;
                display: inline-block;
                margin: 0;
                padding: 0;
            }
        }
    }
}
</style>
